// $ANTLR !Unknown version! BBGrammar.g 2012-10-27 13:36:06

package gdefalll.Grammars;

import java.util.ArrayList;
import org.antlr.runtime.*;

public class BBGrammarParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "LEFT_PAREN", "COMMA", "RIGHT_PAREN", "WORD", "REGISTER", "NUMBER", "UNIFICATOR", "WS"
    };
    public static final int WORD=7;
    public static final int RIGHT_PAREN=6;
    public static final int WS=11;
    public static final int COMMA=5;
    public static final int UNIFICATOR=10;
    public static final int NUMBER=9;
    public static final int LEFT_PAREN=4;
    public static final int EOF=-1;
    public static final int REGISTER=8;

    // delegates
    // delegators


        public BBGrammarParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public BBGrammarParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return BBGrammarParser.tokenNames; }
    public String getGrammarFileName() { return "BBGrammar.g"; }


        private int error_starting_position = -1;
        private ArrayList<String> errors = new ArrayList<String>();
        public void displayRecognitionError(String[] tokenNames,
                                            RecognitionException e)
        {
            String hdr = getErrorHeader(e);
            String msg = getErrorMessage(e, tokenNames);
            errors.add(hdr + " " + msg);
            if (error_starting_position < 0)
            {
    	  error_starting_position = e.charPositionInLine;
            }
        }
        public int getErrorStartingPosition()
        {
          return error_starting_position;
        }
        public ArrayList<String> getErrors()
        {
            return errors;
        }



    // $ANTLR start "parse"
    // BBGrammar.g:37:1: parse : tuple EOF ;
    public final void parse() throws RecognitionException {
        try {
            // BBGrammar.g:38:5: ( tuple EOF )
            // BBGrammar.g:38:10: tuple EOF
            {
            pushFollow(FOLLOW_tuple_in_parse37);
            tuple();

            state._fsp--;

            match(input,EOF,FOLLOW_EOF_in_parse39); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "parse"


    // $ANTLR start "tuple"
    // BBGrammar.g:43:1: tuple : LEFT_PAREN value ( COMMA value )* RIGHT_PAREN ;
    public final void tuple() throws RecognitionException {
        try {
            // BBGrammar.g:44:2: ( LEFT_PAREN value ( COMMA value )* RIGHT_PAREN )
            // BBGrammar.g:44:4: LEFT_PAREN value ( COMMA value )* RIGHT_PAREN
            {
            match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_tuple55); 
            pushFollow(FOLLOW_value_in_tuple57);
            value();

            state._fsp--;

            // BBGrammar.g:44:21: ( COMMA value )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==COMMA) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // BBGrammar.g:44:22: COMMA value
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_tuple60); 
            	    pushFollow(FOLLOW_value_in_tuple62);
            	    value();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_tuple66); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "tuple"


    // $ANTLR start "value"
    // BBGrammar.g:47:1: value : ( WORD | REGISTER | NUMBER | UNIFICATOR | tuple );
    public final void value() throws RecognitionException {
        try {
            // BBGrammar.g:48:2: ( WORD | REGISTER | NUMBER | UNIFICATOR | tuple )
            int alt2=5;
            switch ( input.LA(1) ) {
            case WORD:
                {
                alt2=1;
                }
                break;
            case REGISTER:
                {
                alt2=2;
                }
                break;
            case NUMBER:
                {
                alt2=3;
                }
                break;
            case UNIFICATOR:
                {
                alt2=4;
                }
                break;
            case LEFT_PAREN:
                {
                alt2=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // BBGrammar.g:48:4: WORD
                    {
                    match(input,WORD,FOLLOW_WORD_in_value78); 

                    }
                    break;
                case 2 :
                    // BBGrammar.g:49:4: REGISTER
                    {
                    match(input,REGISTER,FOLLOW_REGISTER_in_value83); 

                    }
                    break;
                case 3 :
                    // BBGrammar.g:50:4: NUMBER
                    {
                    match(input,NUMBER,FOLLOW_NUMBER_in_value88); 

                    }
                    break;
                case 4 :
                    // BBGrammar.g:51:4: UNIFICATOR
                    {
                    match(input,UNIFICATOR,FOLLOW_UNIFICATOR_in_value93); 

                    }
                    break;
                case 5 :
                    // BBGrammar.g:52:4: tuple
                    {
                    pushFollow(FOLLOW_tuple_in_value98);
                    tuple();

                    state._fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "value"

    // Delegated rules


 

    public static final BitSet FOLLOW_tuple_in_parse37 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_parse39 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_tuple55 = new BitSet(new long[]{0x0000000000000790L});
    public static final BitSet FOLLOW_value_in_tuple57 = new BitSet(new long[]{0x0000000000000060L});
    public static final BitSet FOLLOW_COMMA_in_tuple60 = new BitSet(new long[]{0x0000000000000790L});
    public static final BitSet FOLLOW_value_in_tuple62 = new BitSet(new long[]{0x0000000000000060L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_tuple66 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WORD_in_value78 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REGISTER_in_value83 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NUMBER_in_value88 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_UNIFICATOR_in_value93 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_tuple_in_value98 = new BitSet(new long[]{0x0000000000000002L});

}