package gdefalll.gui.actions;

import java.awt.Color;
import javax.swing.ImageIcon;
import gdefalll.gui.MyIcons;

/**
 * Catch Section action.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class CatchSection extends ALLLAction {
	private static final long serialVersionUID = 1L;

	public CatchSection() {
		super();
		setBackground(new Color(255, 128, 0));
	}

	@Override
	ImageIcon getIcon() {		
		return MyIcons.getIcon(MyIcons.Type.CATCH_SECTION);
	}

	@Override
	public String getIdentifier() {
		return "#";
	}

	@Override
	String getLabelText() {
		return "Catch section";
	}

	@Override
	Color getLabelColor() {
		return new Color(0, 0, 0);
	}

	@Override
	public void showEditor() {
	}

	@Override
	public String getALLLCode() {
		return getIdentifier();	
	}

	@Override
	public void setParameters(String params) {
		// No params needed
	}
}
