// $ANTLR !Unknown version! PlanGrammar.g 2012-12-31 00:37:59

package gdefalll.Grammars;
import java.util.ArrayList;
import gdefalll.gui.actions.*;
import org.antlr.runtime.*;

/**
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 *
 * Grammar of ALLL plan.
 * License: BUT OPEN SOURCE LICENCE v.1
 */
public class PlanGrammarParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "LEFT_PAREN", "NUMBER", "COMMA", "RIGHT_PAREN", "REGISTER", "WORD", "PLATFORM_ACTION_IDENTIFIER", "UNIFICATOR", "WS", "'+'", "'-'", "'*'", "'?'", "'!'", "'^'", "'#'", "'@('", "'w'", "'s'", "'a'", "'l'", "'r'", "'g'", "'y'", "'r,1'", "'g,1'", "'y,1'", "'r,0'", "'g,0'", "'y,0'"
    };
    public static final int T__29=29;
    public static final int T__28=28;
    public static final int T__27=27;
    public static final int T__26=26;
    public static final int T__25=25;
    public static final int T__24=24;
    public static final int UNIFICATOR=11;
    public static final int T__23=23;
    public static final int T__22=22;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int PLATFORM_ACTION_IDENTIFIER=10;
    public static final int NUMBER=5;
    public static final int EOF=-1;
    public static final int WORD=9;
    public static final int T__30=30;
    public static final int T__19=19;
    public static final int RIGHT_PAREN=7;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int WS=12;
    public static final int T__33=33;
    public static final int T__16=16;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int COMMA=6;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int LEFT_PAREN=4;
    public static final int REGISTER=8;

    // delegates
    // delegators


        public PlanGrammarParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public PlanGrammarParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return PlanGrammarParser.tokenNames; }
    public String getGrammarFileName() { return "PlanGrammar.g"; }


        private int error_starting_position = -1;
        private ArrayList<String> errors = new ArrayList<String>();
        private ArrayList<ALLLAction> actionList = new ArrayList<ALLLAction>();
        
        public ArrayList<ALLLAction> getActionList()
        {
        	return actionList;
        }
        
        public void displayRecognitionError(String[] tokenNames,
                                            RecognitionException e)
        {
            String hdr = getErrorHeader(e);
            String msg = getErrorMessage(e, tokenNames);
            errors.add(hdr + " " + msg);
            if (error_starting_position < 0)
            {
    	  error_starting_position = e.charPositionInLine;
            }
        }
        public int getErrorStartingPosition()
        {
          return error_starting_position;
        }
        public ArrayList<String> getErrors()
        {
            return errors;
        }



    // $ANTLR start "parse"
    // PlanGrammar.g:51:1: parse : ( action )* EOF ;
    public final void parse() throws RecognitionException {
        try {
            // PlanGrammar.g:52:5: ( ( action )* EOF )
            // PlanGrammar.g:52:10: ( action )* EOF
            {
            // PlanGrammar.g:52:10: ( action )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==PLATFORM_ACTION_IDENTIFIER||(LA1_0>=13 && LA1_0<=20)) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // PlanGrammar.g:52:11: action
            	    {
            	    pushFollow(FOLLOW_action_in_parse40);
            	    action();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            match(input,EOF,FOLLOW_EOF_in_parse44); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "parse"


    // $ANTLR start "action"
    // PlanGrammar.g:57:1: action : ( platform_action | builtin_action );
    public final void action() throws RecognitionException {
        try {
            // PlanGrammar.g:58:2: ( platform_action | builtin_action )
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==PLATFORM_ACTION_IDENTIFIER) ) {
                alt2=1;
            }
            else if ( ((LA2_0>=13 && LA2_0<=20)) ) {
                alt2=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // PlanGrammar.g:58:4: platform_action
                    {
                    pushFollow(FOLLOW_platform_action_in_action60);
                    platform_action();

                    state._fsp--;


                    }
                    break;
                case 2 :
                    // PlanGrammar.g:59:4: builtin_action
                    {
                    pushFollow(FOLLOW_builtin_action_in_action65);
                    builtin_action();

                    state._fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "action"


    // $ANTLR start "builtin_action"
    // PlanGrammar.g:62:1: builtin_action : ( '+' t1= tuple | '-' t2= tuple | '*' t3= tuple | '?' tuple | '!' LEFT_PAREN address5_1= NUMBER COMMA t5_1= tuple RIGHT_PAREN | '!' LEFT_PAREN address5_2= NUMBER COMMA r5_2= REGISTER RIGHT_PAREN | '^' LEFT_PAREN w6= WORD RIGHT_PAREN | '#' | '@(' ( action )* ')' );
    public final void builtin_action() throws RecognitionException {
        Token address5_1=null;
        Token address5_2=null;
        Token r5_2=null;
        Token w6=null;
        PlanGrammarParser.tuple_return t1 = null;

        PlanGrammarParser.tuple_return t2 = null;

        PlanGrammarParser.tuple_return t3 = null;

        PlanGrammarParser.tuple_return t5_1 = null;


        try {
            // PlanGrammar.g:63:2: ( '+' t1= tuple | '-' t2= tuple | '*' t3= tuple | '?' tuple | '!' LEFT_PAREN address5_1= NUMBER COMMA t5_1= tuple RIGHT_PAREN | '!' LEFT_PAREN address5_2= NUMBER COMMA r5_2= REGISTER RIGHT_PAREN | '^' LEFT_PAREN w6= WORD RIGHT_PAREN | '#' | '@(' ( action )* ')' )
            int alt4=9;
            alt4 = dfa4.predict(input);
            switch (alt4) {
                case 1 :
                    // PlanGrammar.g:63:4: '+' t1= tuple
                    {
                    match(input,13,FOLLOW_13_in_builtin_action76); 
                    pushFollow(FOLLOW_tuple_in_builtin_action80);
                    t1=tuple();

                    state._fsp--;

                    	ALLLAction action = new AddBB();
                    						action.setParameters((t1!=null?input.toString(t1.start,t1.stop):null));
                    						actionList.add(action);
                    						

                    }
                    break;
                case 2 :
                    // PlanGrammar.g:67:4: '-' t2= tuple
                    {
                    match(input,14,FOLLOW_14_in_builtin_action87); 
                    pushFollow(FOLLOW_tuple_in_builtin_action91);
                    t2=tuple();

                    state._fsp--;

                    	ALLLAction action = new DelBB();
                    						action.setParameters((t2!=null?input.toString(t2.start,t2.stop):null));
                    						actionList.add(action);
                    						

                    }
                    break;
                case 3 :
                    // PlanGrammar.g:71:4: '*' t3= tuple
                    {
                    match(input,15,FOLLOW_15_in_builtin_action98); 
                    pushFollow(FOLLOW_tuple_in_builtin_action102);
                    t3=tuple();

                    state._fsp--;

                    	ALLLAction action = new CheckBB();
                    						action.setParameters((t3!=null?input.toString(t3.start,t3.stop):null));
                    						actionList.add(action);
                    						

                    }
                    break;
                case 4 :
                    // PlanGrammar.g:75:4: '?' tuple
                    {
                    match(input,16,FOLLOW_16_in_builtin_action109); 
                    pushFollow(FOLLOW_tuple_in_builtin_action111);
                    tuple();

                    state._fsp--;

                    	ALLLAction action = new CheckInputBase();
                    						actionList.add(action);
                    						

                    }
                    break;
                case 5 :
                    // PlanGrammar.g:78:4: '!' LEFT_PAREN address5_1= NUMBER COMMA t5_1= tuple RIGHT_PAREN
                    {
                    match(input,17,FOLLOW_17_in_builtin_action118); 
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_builtin_action120); 
                    address5_1=(Token)match(input,NUMBER,FOLLOW_NUMBER_in_builtin_action124); 
                    match(input,COMMA,FOLLOW_COMMA_in_builtin_action126); 
                    pushFollow(FOLLOW_tuple_in_builtin_action130);
                    t5_1=tuple();

                    state._fsp--;

                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_builtin_action132); 
                    	ALLLAction action = new MessageOutput();
                    																		action.setParameters((address5_1!=null?address5_1.getText():null) + ',' + (t5_1!=null?input.toString(t5_1.start,t5_1.stop):null));
                    																		actionList.add(action);
                    																		

                    }
                    break;
                case 6 :
                    // PlanGrammar.g:82:4: '!' LEFT_PAREN address5_2= NUMBER COMMA r5_2= REGISTER RIGHT_PAREN
                    {
                    match(input,17,FOLLOW_17_in_builtin_action139); 
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_builtin_action141); 
                    address5_2=(Token)match(input,NUMBER,FOLLOW_NUMBER_in_builtin_action145); 
                    match(input,COMMA,FOLLOW_COMMA_in_builtin_action147); 
                    r5_2=(Token)match(input,REGISTER,FOLLOW_REGISTER_in_builtin_action151); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_builtin_action153); 
                    	ALLLAction action = new MessageOutput();
                    																			action.setParameters((address5_2!=null?address5_2.getText():null) + ',' + (r5_2!=null?r5_2.getText():null));
                    																			actionList.add(action);
                    																			

                    }
                    break;
                case 7 :
                    // PlanGrammar.g:86:4: '^' LEFT_PAREN w6= WORD RIGHT_PAREN
                    {
                    match(input,18,FOLLOW_18_in_builtin_action160); 
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_builtin_action162); 
                    w6=(Token)match(input,WORD,FOLLOW_WORD_in_builtin_action166); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_builtin_action168); 
                    	ALLLAction action = new RemotePlan();
                    												action.setParameters((w6!=null?w6.getText():null));
                    												actionList.add(action);
                    												

                    }
                    break;
                case 8 :
                    // PlanGrammar.g:90:4: '#'
                    {
                    match(input,19,FOLLOW_19_in_builtin_action175); 
                    	ALLLAction action = new CatchSection();
                    				actionList.add(action);
                    				

                    }
                    break;
                case 9 :
                    // PlanGrammar.g:94:4: '@(' ( action )* ')'
                    {
                    match(input,20,FOLLOW_20_in_builtin_action184); 
                    InternalPlanStart actionStart = new InternalPlanStart(); actionList.add(actionStart);
                    // PlanGrammar.g:95:3: ( action )*
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( (LA3_0==PLATFORM_ACTION_IDENTIFIER||(LA3_0>=13 && LA3_0<=20)) ) {
                            alt3=1;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // PlanGrammar.g:95:4: action
                    	    {
                    	    pushFollow(FOLLOW_action_in_builtin_action191);
                    	    action();

                    	    state._fsp--;


                    	    }
                    	    break;

                    	default :
                    	    break loop3;
                        }
                    } while (true);

                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_builtin_action195); 
                    	InternalPlanEnd actionStop = new InternalPlanEnd();
                    								
                    								actionStop.setNestedAction((ALLLAction)actionStart);
                    								actionStart.setNestedAction((ALLLAction)actionStop);								
                    								actionList.add(actionStop);
                    								

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "builtin_action"


    // $ANTLR start "platform_action"
    // PlanGrammar.g:105:1: platform_action : PLATFORM_ACTION_IDENTIFIER platform_action_type ;
    public final void platform_action() throws RecognitionException {
        try {
            // PlanGrammar.g:106:2: ( PLATFORM_ACTION_IDENTIFIER platform_action_type )
            // PlanGrammar.g:106:4: PLATFORM_ACTION_IDENTIFIER platform_action_type
            {
            match(input,PLATFORM_ACTION_IDENTIFIER,FOLLOW_PLATFORM_ACTION_IDENTIFIER_in_platform_action216); 
            pushFollow(FOLLOW_platform_action_type_in_platform_action218);
            platform_action_type();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "platform_action"


    // $ANTLR start "platform_action_type"
    // PlanGrammar.g:109:1: platform_action_type : ( LEFT_PAREN 'w' COMMA LEFT_PAREN pn1= NUMBER RIGHT_PAREN RIGHT_PAREN | LEFT_PAREN 'w' COMMA pr1= REGISTER RIGHT_PAREN | LEFT_PAREN 's' RIGHT_PAREN | LEFT_PAREN 'a' RIGHT_PAREN | LEFT_PAREN 'l' COMMA params_led= led_action_possible_params RIGHT_PAREN );
    public final void platform_action_type() throws RecognitionException {
        Token pn1=null;
        Token pr1=null;

        try {
            // PlanGrammar.g:110:2: ( LEFT_PAREN 'w' COMMA LEFT_PAREN pn1= NUMBER RIGHT_PAREN RIGHT_PAREN | LEFT_PAREN 'w' COMMA pr1= REGISTER RIGHT_PAREN | LEFT_PAREN 's' RIGHT_PAREN | LEFT_PAREN 'a' RIGHT_PAREN | LEFT_PAREN 'l' COMMA params_led= led_action_possible_params RIGHT_PAREN )
            int alt5=5;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==LEFT_PAREN) ) {
                switch ( input.LA(2) ) {
                case 21:
                    {
                    int LA5_2 = input.LA(3);

                    if ( (LA5_2==COMMA) ) {
                        int LA5_6 = input.LA(4);

                        if ( (LA5_6==LEFT_PAREN) ) {
                            alt5=1;
                        }
                        else if ( (LA5_6==REGISTER) ) {
                            alt5=2;
                        }
                        else {
                            NoViableAltException nvae =
                                new NoViableAltException("", 5, 6, input);

                            throw nvae;
                        }
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 5, 2, input);

                        throw nvae;
                    }
                    }
                    break;
                case 22:
                    {
                    alt5=3;
                    }
                    break;
                case 23:
                    {
                    alt5=4;
                    }
                    break;
                case 24:
                    {
                    alt5=5;
                    }
                    break;
                default:
                    NoViableAltException nvae =
                        new NoViableAltException("", 5, 1, input);

                    throw nvae;
                }

            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }
            switch (alt5) {
                case 1 :
                    // PlanGrammar.g:110:4: LEFT_PAREN 'w' COMMA LEFT_PAREN pn1= NUMBER RIGHT_PAREN RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_platform_action_type229); 
                    match(input,21,FOLLOW_21_in_platform_action_type231); 
                    match(input,COMMA,FOLLOW_COMMA_in_platform_action_type233); 
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_platform_action_type235); 
                    pn1=(Token)match(input,NUMBER,FOLLOW_NUMBER_in_platform_action_type239); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_platform_action_type241); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_platform_action_type243); 
                    	ALLLAction action = new WaitTime();
                    																				action.setParameters((pn1!=null?pn1.getText():null));
                    																				actionList.add(action);
                    																				

                    }
                    break;
                case 2 :
                    // PlanGrammar.g:114:4: LEFT_PAREN 'w' COMMA pr1= REGISTER RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_platform_action_type250); 
                    match(input,21,FOLLOW_21_in_platform_action_type252); 
                    match(input,COMMA,FOLLOW_COMMA_in_platform_action_type254); 
                    pr1=(Token)match(input,REGISTER,FOLLOW_REGISTER_in_platform_action_type258); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_platform_action_type260); 
                    	ALLLAction action = new WaitTime();
                    														action.setParameters((pr1!=null?pr1.getText():null));
                    														actionList.add(action);
                    														

                    }
                    break;
                case 3 :
                    // PlanGrammar.g:118:4: LEFT_PAREN 's' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_platform_action_type267); 
                    match(input,22,FOLLOW_22_in_platform_action_type269); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_platform_action_type271); 
                    	ALLLAction action = new WaitMsg();
                    										actionList.add(action);
                    										

                    }
                    break;
                case 4 :
                    // PlanGrammar.g:121:4: LEFT_PAREN 'a' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_platform_action_type278); 
                    match(input,23,FOLLOW_23_in_platform_action_type280); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_platform_action_type282); 
                    	ALLLAction action = new StartMsgWait();
                    										actionList.add(action);
                    										

                    }
                    break;
                case 5 :
                    // PlanGrammar.g:124:4: LEFT_PAREN 'l' COMMA params_led= led_action_possible_params RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_platform_action_type289); 
                    match(input,24,FOLLOW_24_in_platform_action_type291); 
                    match(input,COMMA,FOLLOW_COMMA_in_platform_action_type293); 
                    pushFollow(FOLLOW_led_action_possible_params_in_platform_action_type297);
                    led_action_possible_params();

                    state._fsp--;

                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_platform_action_type299); 


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "platform_action_type"


    // $ANTLR start "led_action_possible_params"
    // PlanGrammar.g:127:1: led_action_possible_params : (plr1= REGISTER | LEFT_PAREN 'r' RIGHT_PAREN | LEFT_PAREN 'g' RIGHT_PAREN | LEFT_PAREN 'y' RIGHT_PAREN | LEFT_PAREN 'r,1' RIGHT_PAREN | LEFT_PAREN 'g,1' RIGHT_PAREN | LEFT_PAREN 'y,1' RIGHT_PAREN | LEFT_PAREN 'r,0' RIGHT_PAREN | LEFT_PAREN 'g,0' RIGHT_PAREN | LEFT_PAREN 'y,0' RIGHT_PAREN );
    public final void led_action_possible_params() throws RecognitionException {
        Token plr1=null;

        try {
            // PlanGrammar.g:128:2: (plr1= REGISTER | LEFT_PAREN 'r' RIGHT_PAREN | LEFT_PAREN 'g' RIGHT_PAREN | LEFT_PAREN 'y' RIGHT_PAREN | LEFT_PAREN 'r,1' RIGHT_PAREN | LEFT_PAREN 'g,1' RIGHT_PAREN | LEFT_PAREN 'y,1' RIGHT_PAREN | LEFT_PAREN 'r,0' RIGHT_PAREN | LEFT_PAREN 'g,0' RIGHT_PAREN | LEFT_PAREN 'y,0' RIGHT_PAREN )
            int alt6=10;
            alt6 = dfa6.predict(input);
            switch (alt6) {
                case 1 :
                    // PlanGrammar.g:128:4: plr1= REGISTER
                    {
                    plr1=(Token)match(input,REGISTER,FOLLOW_REGISTER_in_led_action_possible_params334); 
                    	ALLLAction action = new Leds();
                    						action.setParameters((plr1!=null?plr1.getText():null));
                    						actionList.add(action);
                    						

                    }
                    break;
                case 2 :
                    // PlanGrammar.g:132:4: LEFT_PAREN 'r' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_led_action_possible_params341); 
                    match(input,25,FOLLOW_25_in_led_action_possible_params343); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_led_action_possible_params345); 
                    	ALLLAction action = new Leds();
                    										action.setParameters("RED TOGGLE");
                    										actionList.add(action);
                    										

                    }
                    break;
                case 3 :
                    // PlanGrammar.g:136:4: LEFT_PAREN 'g' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_led_action_possible_params352); 
                    match(input,26,FOLLOW_26_in_led_action_possible_params354); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_led_action_possible_params356); 
                    	ALLLAction action = new Leds();
                    										action.setParameters("GREEN TOGGLE");
                    										actionList.add(action);
                    										

                    }
                    break;
                case 4 :
                    // PlanGrammar.g:140:4: LEFT_PAREN 'y' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_led_action_possible_params363); 
                    match(input,27,FOLLOW_27_in_led_action_possible_params365); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_led_action_possible_params367); 
                    	ALLLAction action = new Leds();
                    										action.setParameters("YELLOW TOGGLE");
                    										actionList.add(action);
                    										

                    }
                    break;
                case 5 :
                    // PlanGrammar.g:144:4: LEFT_PAREN 'r,1' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_led_action_possible_params374); 
                    match(input,28,FOLLOW_28_in_led_action_possible_params376); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_led_action_possible_params378); 
                    	ALLLAction action = new Leds();
                    										action.setParameters("RED ON");
                    										actionList.add(action);
                    										

                    }
                    break;
                case 6 :
                    // PlanGrammar.g:148:4: LEFT_PAREN 'g,1' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_led_action_possible_params385); 
                    match(input,29,FOLLOW_29_in_led_action_possible_params387); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_led_action_possible_params389); 
                    	ALLLAction action = new Leds();
                    										action.setParameters("GREEN ON");
                    										actionList.add(action);
                    										

                    }
                    break;
                case 7 :
                    // PlanGrammar.g:152:4: LEFT_PAREN 'y,1' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_led_action_possible_params396); 
                    match(input,30,FOLLOW_30_in_led_action_possible_params398); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_led_action_possible_params400); 
                    	ALLLAction action = new Leds();
                    										action.setParameters("YELLOW ON");
                    										actionList.add(action);
                    										

                    }
                    break;
                case 8 :
                    // PlanGrammar.g:156:4: LEFT_PAREN 'r,0' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_led_action_possible_params407); 
                    match(input,31,FOLLOW_31_in_led_action_possible_params409); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_led_action_possible_params411); 
                    	ALLLAction action = new Leds();
                    										action.setParameters("RED OFF");
                    										actionList.add(action);
                    										

                    }
                    break;
                case 9 :
                    // PlanGrammar.g:160:4: LEFT_PAREN 'g,0' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_led_action_possible_params418); 
                    match(input,32,FOLLOW_32_in_led_action_possible_params420); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_led_action_possible_params422); 
                    	ALLLAction action = new Leds();
                    										action.setParameters("GREEN OFF");
                    										actionList.add(action);
                    										

                    }
                    break;
                case 10 :
                    // PlanGrammar.g:164:4: LEFT_PAREN 'y,0' RIGHT_PAREN
                    {
                    match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_led_action_possible_params429); 
                    match(input,33,FOLLOW_33_in_led_action_possible_params431); 
                    match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_led_action_possible_params433); 
                    	ALLLAction action = new Leds();
                    										action.setParameters("YELLOW OFF");
                    										actionList.add(action);
                    										

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "led_action_possible_params"

    public static class tuple_return extends ParserRuleReturnScope {
    };

    // $ANTLR start "tuple"
    // PlanGrammar.g:171:1: tuple : LEFT_PAREN value ( COMMA value )* RIGHT_PAREN ;
    public final PlanGrammarParser.tuple_return tuple() throws RecognitionException {
        PlanGrammarParser.tuple_return retval = new PlanGrammarParser.tuple_return();
        retval.start = input.LT(1);

        try {
            // PlanGrammar.g:172:2: ( LEFT_PAREN value ( COMMA value )* RIGHT_PAREN )
            // PlanGrammar.g:172:4: LEFT_PAREN value ( COMMA value )* RIGHT_PAREN
            {
            match(input,LEFT_PAREN,FOLLOW_LEFT_PAREN_in_tuple447); 
            pushFollow(FOLLOW_value_in_tuple449);
            value();

            state._fsp--;

            // PlanGrammar.g:172:21: ( COMMA value )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==COMMA) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // PlanGrammar.g:172:22: COMMA value
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_tuple452); 
            	    pushFollow(FOLLOW_value_in_tuple454);
            	    value();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);

            match(input,RIGHT_PAREN,FOLLOW_RIGHT_PAREN_in_tuple458); 

            }

            retval.stop = input.LT(-1);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "tuple"


    // $ANTLR start "value"
    // PlanGrammar.g:175:1: value : ( WORD | REGISTER | NUMBER | UNIFICATOR | tuple );
    public final void value() throws RecognitionException {
        try {
            // PlanGrammar.g:176:2: ( WORD | REGISTER | NUMBER | UNIFICATOR | tuple )
            int alt8=5;
            switch ( input.LA(1) ) {
            case WORD:
                {
                alt8=1;
                }
                break;
            case REGISTER:
                {
                alt8=2;
                }
                break;
            case NUMBER:
                {
                alt8=3;
                }
                break;
            case UNIFICATOR:
                {
                alt8=4;
                }
                break;
            case LEFT_PAREN:
                {
                alt8=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }

            switch (alt8) {
                case 1 :
                    // PlanGrammar.g:176:4: WORD
                    {
                    match(input,WORD,FOLLOW_WORD_in_value470); 

                    }
                    break;
                case 2 :
                    // PlanGrammar.g:177:4: REGISTER
                    {
                    match(input,REGISTER,FOLLOW_REGISTER_in_value475); 

                    }
                    break;
                case 3 :
                    // PlanGrammar.g:178:4: NUMBER
                    {
                    match(input,NUMBER,FOLLOW_NUMBER_in_value480); 

                    }
                    break;
                case 4 :
                    // PlanGrammar.g:179:4: UNIFICATOR
                    {
                    match(input,UNIFICATOR,FOLLOW_UNIFICATOR_in_value485); 

                    }
                    break;
                case 5 :
                    // PlanGrammar.g:180:4: tuple
                    {
                    pushFollow(FOLLOW_tuple_in_value490);
                    tuple();

                    state._fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "value"

    // Delegated rules


    protected DFA4 dfa4 = new DFA4(this);
    protected DFA6 dfa6 = new DFA6(this);
    static final String DFA4_eotS =
        "\16\uffff";
    static final String DFA4_eofS =
        "\16\uffff";
    static final String DFA4_minS =
        "\1\15\4\uffff\1\4\3\uffff\1\5\1\6\1\4\2\uffff";
    static final String DFA4_maxS =
        "\1\24\4\uffff\1\4\3\uffff\1\5\1\6\1\10\2\uffff";
    static final String DFA4_acceptS =
        "\1\uffff\1\1\1\2\1\3\1\4\1\uffff\1\7\1\10\1\11\3\uffff\1\6\1\5";
    static final String DFA4_specialS =
        "\16\uffff}>";
    static final String[] DFA4_transitionS = {
            "\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10",
            "",
            "",
            "",
            "",
            "\1\11",
            "",
            "",
            "",
            "\1\12",
            "\1\13",
            "\1\15\3\uffff\1\14",
            "",
            ""
    };

    static final short[] DFA4_eot = DFA.unpackEncodedString(DFA4_eotS);
    static final short[] DFA4_eof = DFA.unpackEncodedString(DFA4_eofS);
    static final char[] DFA4_min = DFA.unpackEncodedStringToUnsignedChars(DFA4_minS);
    static final char[] DFA4_max = DFA.unpackEncodedStringToUnsignedChars(DFA4_maxS);
    static final short[] DFA4_accept = DFA.unpackEncodedString(DFA4_acceptS);
    static final short[] DFA4_special = DFA.unpackEncodedString(DFA4_specialS);
    static final short[][] DFA4_transition;

    static {
        int numStates = DFA4_transitionS.length;
        DFA4_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA4_transition[i] = DFA.unpackEncodedString(DFA4_transitionS[i]);
        }
    }

    class DFA4 extends DFA {

        public DFA4(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 4;
            this.eot = DFA4_eot;
            this.eof = DFA4_eof;
            this.min = DFA4_min;
            this.max = DFA4_max;
            this.accept = DFA4_accept;
            this.special = DFA4_special;
            this.transition = DFA4_transition;
        }
        public String getDescription() {
            return "62:1: builtin_action : ( '+' t1= tuple | '-' t2= tuple | '*' t3= tuple | '?' tuple | '!' LEFT_PAREN address5_1= NUMBER COMMA t5_1= tuple RIGHT_PAREN | '!' LEFT_PAREN address5_2= NUMBER COMMA r5_2= REGISTER RIGHT_PAREN | '^' LEFT_PAREN w6= WORD RIGHT_PAREN | '#' | '@(' ( action )* ')' );";
        }
    }
    static final String DFA6_eotS =
        "\14\uffff";
    static final String DFA6_eofS =
        "\14\uffff";
    static final String DFA6_minS =
        "\1\4\1\uffff\1\31\11\uffff";
    static final String DFA6_maxS =
        "\1\10\1\uffff\1\41\11\uffff";
    static final String DFA6_acceptS =
        "\1\uffff\1\1\1\uffff\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12";
    static final String DFA6_specialS =
        "\14\uffff}>";
    static final String[] DFA6_transitionS = {
            "\1\2\3\uffff\1\1",
            "",
            "\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA6_eot = DFA.unpackEncodedString(DFA6_eotS);
    static final short[] DFA6_eof = DFA.unpackEncodedString(DFA6_eofS);
    static final char[] DFA6_min = DFA.unpackEncodedStringToUnsignedChars(DFA6_minS);
    static final char[] DFA6_max = DFA.unpackEncodedStringToUnsignedChars(DFA6_maxS);
    static final short[] DFA6_accept = DFA.unpackEncodedString(DFA6_acceptS);
    static final short[] DFA6_special = DFA.unpackEncodedString(DFA6_specialS);
    static final short[][] DFA6_transition;

    static {
        int numStates = DFA6_transitionS.length;
        DFA6_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA6_transition[i] = DFA.unpackEncodedString(DFA6_transitionS[i]);
        }
    }

    class DFA6 extends DFA {

        public DFA6(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 6;
            this.eot = DFA6_eot;
            this.eof = DFA6_eof;
            this.min = DFA6_min;
            this.max = DFA6_max;
            this.accept = DFA6_accept;
            this.special = DFA6_special;
            this.transition = DFA6_transition;
        }
        public String getDescription() {
            return "127:1: led_action_possible_params : (plr1= REGISTER | LEFT_PAREN 'r' RIGHT_PAREN | LEFT_PAREN 'g' RIGHT_PAREN | LEFT_PAREN 'y' RIGHT_PAREN | LEFT_PAREN 'r,1' RIGHT_PAREN | LEFT_PAREN 'g,1' RIGHT_PAREN | LEFT_PAREN 'y,1' RIGHT_PAREN | LEFT_PAREN 'r,0' RIGHT_PAREN | LEFT_PAREN 'g,0' RIGHT_PAREN | LEFT_PAREN 'y,0' RIGHT_PAREN );";
        }
    }
 

    public static final BitSet FOLLOW_action_in_parse40 = new BitSet(new long[]{0x00000000001FE400L});
    public static final BitSet FOLLOW_EOF_in_parse44 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_platform_action_in_action60 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_builtin_action_in_action65 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_13_in_builtin_action76 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_tuple_in_builtin_action80 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_builtin_action87 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_tuple_in_builtin_action91 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_15_in_builtin_action98 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_tuple_in_builtin_action102 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_16_in_builtin_action109 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_tuple_in_builtin_action111 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_builtin_action118 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_builtin_action120 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_NUMBER_in_builtin_action124 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_COMMA_in_builtin_action126 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_tuple_in_builtin_action130 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_builtin_action132 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_builtin_action139 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_builtin_action141 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_NUMBER_in_builtin_action145 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_COMMA_in_builtin_action147 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_REGISTER_in_builtin_action151 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_builtin_action153 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_18_in_builtin_action160 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_builtin_action162 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_WORD_in_builtin_action166 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_builtin_action168 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_19_in_builtin_action175 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_20_in_builtin_action184 = new BitSet(new long[]{0x00000000001FE480L});
    public static final BitSet FOLLOW_action_in_builtin_action191 = new BitSet(new long[]{0x00000000001FE480L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_builtin_action195 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLATFORM_ACTION_IDENTIFIER_in_platform_action216 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_platform_action_type_in_platform_action218 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_platform_action_type229 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_21_in_platform_action_type231 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_COMMA_in_platform_action_type233 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_platform_action_type235 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_NUMBER_in_platform_action_type239 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_platform_action_type241 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_platform_action_type243 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_platform_action_type250 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_21_in_platform_action_type252 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_COMMA_in_platform_action_type254 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_REGISTER_in_platform_action_type258 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_platform_action_type260 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_platform_action_type267 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_22_in_platform_action_type269 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_platform_action_type271 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_platform_action_type278 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_platform_action_type280 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_platform_action_type282 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_platform_action_type289 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_24_in_platform_action_type291 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_COMMA_in_platform_action_type293 = new BitSet(new long[]{0x0000000000000110L});
    public static final BitSet FOLLOW_led_action_possible_params_in_platform_action_type297 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_platform_action_type299 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REGISTER_in_led_action_possible_params334 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_led_action_possible_params341 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_25_in_led_action_possible_params343 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_led_action_possible_params345 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_led_action_possible_params352 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_26_in_led_action_possible_params354 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_led_action_possible_params356 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_led_action_possible_params363 = new BitSet(new long[]{0x0000000008000000L});
    public static final BitSet FOLLOW_27_in_led_action_possible_params365 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_led_action_possible_params367 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_led_action_possible_params374 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_led_action_possible_params376 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_led_action_possible_params378 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_led_action_possible_params385 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_29_in_led_action_possible_params387 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_led_action_possible_params389 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_led_action_possible_params396 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_led_action_possible_params398 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_led_action_possible_params400 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_led_action_possible_params407 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_31_in_led_action_possible_params409 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_led_action_possible_params411 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_led_action_possible_params418 = new BitSet(new long[]{0x0000000100000000L});
    public static final BitSet FOLLOW_32_in_led_action_possible_params420 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_led_action_possible_params422 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_led_action_possible_params429 = new BitSet(new long[]{0x0000000200000000L});
    public static final BitSet FOLLOW_33_in_led_action_possible_params431 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_led_action_possible_params433 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LEFT_PAREN_in_tuple447 = new BitSet(new long[]{0x0000000000000B30L});
    public static final BitSet FOLLOW_value_in_tuple449 = new BitSet(new long[]{0x00000000000000C0L});
    public static final BitSet FOLLOW_COMMA_in_tuple452 = new BitSet(new long[]{0x0000000000000B30L});
    public static final BitSet FOLLOW_value_in_tuple454 = new BitSet(new long[]{0x00000000000000C0L});
    public static final BitSet FOLLOW_RIGHT_PAREN_in_tuple458 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WORD_in_value470 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REGISTER_in_value475 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NUMBER_in_value480 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_UNIFICATOR_in_value485 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_tuple_in_value490 = new BitSet(new long[]{0x0000000000000002L});

}