package gdefalll.events;


import java.util.ArrayList;
import java.util.Iterator;

public class PlanChangedGenerator {
	private ArrayList<PlanChangedListener> _listeners = new ArrayList<PlanChangedListener>();
    
    public synchronized void addListener( PlanChangedListener l ) {
        _listeners.add( l );
    }
    
    public synchronized void removeListener( PlanChangedListener l ) {
        _listeners.remove( l );
    }
     
    public synchronized void firePlanChanged() {
        Iterator<PlanChangedListener> listeners = _listeners.iterator();
        while( listeners.hasNext() ) {
            ( (PlanChangedListener) listeners.next() ).planChanged();
        }
    }
}
