package gdefalll.gui.actions;

import java.awt.Color;
import javax.swing.ImageIcon;
import gdefalll.gui.MyIcons;

/**
 * Check Input Base action.
 * License: BUT OPEN SOURCE LICENCE v.1
 * 
 * @author Jan Horacek <ihoracek@fit.vutbr.cz>
 */
public class CheckInputBase extends ALLLAction {

	private static final long serialVersionUID = 1L;

	public CheckInputBase() {
		super();
	}

	@Override
	ImageIcon getIcon() {		
		return MyIcons.getIcon(MyIcons.Type.CHECK_IB);
	}

	@Override
	public String getIdentifier() {
		return "?";
	}

	@Override
	String getLabelText() {
		return "Check IB";
	}

	@Override
	Color getLabelColor() {
		return new Color(0, 0, 0);
	}

	@Override
	public void showEditor() {
	}

	@Override
	public String getALLLCode() {
		return getIdentifier() + "(_)";	
	}

	@Override
	public void setParameters(String params) {
		// TODO ...
		
	}
}
